--Call dibs on slots for sounds
freeslot("sfx_fstep0", "sfx_kstep1", "sfx_msjet0", "sfx_msdsh0")

-- Define feet sounds and timing for each of the default characters
local feet = {}
feet["sonic"] = {
					landingsfx = {slow = nil},
					walksfx = {nil},
					runsfx = {nil},
					dashsfx = {nil},
					walktiming = function(x) return x==2 or x==6 or x==1048578 or x==1048582 end,
					runtiming = function(x) return x==1 or x==3 end,
					dashtiming = function() return leveltime % 11 == 0 end,
				}
feet["tails"] = {
					landingsfx = {slow = nil, fast = nil},
					walksfx = {nil},
					runsfx = {sfx_s3kba},
					dashsfx = {nil},
					walktiming = function(x) return x==3 or x==7 end,
					runtiming = function() return leveltime % 10 == 0 or leveltime % 10 == 1 end,
					dashtiming = function() return leveltime % 11 == 0 end,
					airrun = true
				}
feet["knuckles"] = {
					landingsfx = {slow = sfx_s3k4c},
					walksfx = {sfx_kstep1},
					runsfx = {sfx_kstep1},
					dashsfx = {nil},
					walktiming = function(x) return x==2 or x==6 end,
					runtiming = function(x) return x==1 or x==3 end,
					dashtiming = function() return leveltime % 11 == 0 end,
				}
feet["amy"] = {
					landingsfx = {slow = nil},
					walksfx = {nil},
					runsfx = {nil},
					dashsfx = {nil},
					walktiming = function(x) return x==3 or x==7 end,
					runtiming = function(x) return x==2 or x==6 end,
					dashtiming = function() return leveltime % 11 == 0 end,
				}
feet["fang"] = {
					landingsfx = {slow = nil},
					walksfx = {nil},
					runsfx = {nil},
					dashsfx = {nil},
					walktiming = function(x) return x==3 or x==7 end,
					runtiming = function(x) return x==1 or x==4 end,
					dashtiming = function() return leveltime % 11 == 0 end,
				}
feet["metalsonic"] = {
					landingsfx = {slow = sfx_s3k4c},
					walksfx = {sfx_msjet0},
					runsfx = {sfx_msjet0},
					dashsfx = {sfx_msdsh0},
					walktiming = function() return leveltime % 4 == 0 end,
					runtiming = function() return leveltime % 4 == 0 end,
					dashtiming = function() return leveltime % 11 == 0 end,
					airwalk = true,
					airrun = true,
					stiff = true
				}
feet["default"] = {
					landingsfx = {slow = nil},
					walksfx = {nil},
					runsfx = {nil},
					dashsfx = {nil},
					walktiming = function(x) return x==2 or x==6 or x==1048578 or x==1048582 end,
					runtiming = function(x) return x==1 or x==3 end,
					dashtiming = function() return leveltime % 11 == 0 end,
				}

-- Console variable that controls whether custom characters have basic feet sounds or none
CV_RegisterVar({ name = "defaultfeet",
    defaultvalue = "1",
    flags = CV_SHOWMODIF,
    PossibleValue = {Silent = 0, Simple = 1}
    })

-- Assign the player's feet settings based on their current skin
addHook("PreThinkFrame", function()
	for player in players.iterate()
		if not (player.mo and player.mo.valid)
			continue
		end
		
		-- Pick feet settings for the player based on their skin
		-- If their skin isn't defined here, see if they already have feet settings (ie defined by a custom character)
		player.feet = feet[player.mo.skin]
		
		-- If default feet console var is set to 1, give them default feet sounds
		if player.feet == nil and CV_FindVar("defaultfeet").value == 1
			player.feet = feet["default"]
		end
	end
end)
